#include "protocol.h"
#include "stdio.h"

int main(){
    printf("Test number\n");
    char number = 112;
    uint8_t buffer_number[] = {};
    size_t len_buffer_number;
    protocol_encode_number(number, buffer_number, &len_buffer_number);
    for (int i = 0; i < len_buffer_number; i++){
        printf("buffer %d: %d\n", i, buffer_number[i]);
    }

    printf("---------------------------------------\n");

    char encode_message_number[] = {};
    size_t len_message_number;
    protocol_decode(buffer_number, len_buffer_number, encode_message_number, &len_message_number);
    printf("number: %d\n", encode_message_number[0]);

    printf("\nTest word\n");
    char* word = "word";
    uint8_t buffer[] = {};
    size_t len_buffer;
    protocol_encode_word(word, strlen(word), buffer, &len_buffer);
    for (int i = 0; i < len_buffer; i++){
        printf("buffer %d: %d\n", i, buffer[i]);
    }

    printf("---------------------------------------\n");

    char encode_message[] = {};
    size_t len_message;
    protocol_decode(buffer, len_buffer, encode_message, &len_message);
    printf("message: %s\n", encode_message);
    return 0;
}