#ifndef PROTOCOL_H
#define PROTOCOL_H

#include <stdint.h>
#include <string.h>

#define FLAG_NUMBER 0
#define FLAG_WORD 1

void protocol_decode(uint8_t encode_message[], size_t len_encode_message, char decode_message[], size_t* len_decode_message);
void protocol_encode_number(char number, uint8_t encode_message[], size_t* len_encode_message);
void protocol_encode_word(char decode_word[], size_t len_encode_word, uint8_t encode_message[], size_t* len_encode_message);

#endif //PROTOCOL_H
